
What's New So Far in Resonic Pro + Player
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

This log is for Alpha versions, which are not intended for production use.

Comment, report, and discuss at:
 https://discord.liqube.com (primary)
 https://bugs.liqube.com
 https://forums.liqube.com

Current Alpha (2025-01-29)
~~~~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- Moved themes menu to the main menu for easy access, just below 'Sound Banks'.
- Themes can now be loaded via main menu. Depending on whether the dark or light
  theme is currently active, it will be replaced by the theme you load.
  You can also make custom themes now and place them in folders in Portable/Themes/,
  e.g. Portable/Themes/My Dark Theme/theme.ini
- Twittler links removed.

User Interface:

- Now showing Soundfont file sizes in megabytes in 'Sound Banks' menu.
  File scan has been sped up as well.
  Packed soundfonts (e.g. .sf2pack) will be marked with "(pack)".

Browser:

- Individual folders can now be cut to clipboard using CTRL+X, or via menu.
  Note that CTRL+C for copy, also via menu, works too.
  Make sure the browser is active (TAB) before cutting a folder.
  The item will appear dimmed and say 'cut' next to it, same as the file list.

Alpha 2333 (2025-01-28)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- Fixed crash when opening sound card settings, not related to sound cards.
  Could happen in other places too.

Alpha 2317 (2025-01-20)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- Enabled user theme access for Alpha testing.
  To start experimenting go to your 'Portable/Themes/' directory and either create and start
   editing 'Testing Dark/theme.ini' or 'Testing Light/theme.ini'.
  If you did it right the next Resonic startup (or switch to either dark or light theme)
   will greet you with a black minimalistic style.
  Press CTRL+ALT+F12 to reload the current theme. You don't have to restart Resonic.
  There is a way to automatically reload it too.
  Then head over to the #themes channel on the LA Discord for discussion.

Browser:

- When you drag a folder on top of another folder while holding down CTRL or SHIFT
   it will no longer auto-expand its subfolders because your intent is clearly
    to either copy or move the folder there.
  The target folder will still auto-expand when you don't hold down any shift keys.

Sound:

- Pro: Changed 'First output' channel setting for ASIO output to start at 1, rather than 0.
  All output channels which are active will be marked as such in the popup, which also depends
   on the channel limit you might have set up.
  To only use ASIO output channels 5 to 8 of your audio interface, for exampe,
   set 'First output' to 5 and 'Channels' to 'Limit to 4'.
    (suggested: BucketHat)

Alpha 2315 (2025-01-02)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- Lots of smaller internal changes.

Metadata:

- Metacore now understands track numbers in format "1/9", and all variations thereof.
- Fixed a very rarely occuring detection bug that would make any playable file in Resonic
   appear as unplayable and produce an error message.
- Naive UTF-8 detection for ID3v1 tags.
  This is a workaround for invalid ID3v1 tags which technically must not contain anything but
   Latin-1 text, but several applications decide to ignore this.
  Resonic will lower the file's meta quality rating when it encounters such content.
  It's best to not use ID3v1 tags anymore as they are beyond outdated.
- Pro: Custom support for user keywords (separated with commas or semicolons):
  - In WAVE files use 'IKEY' in INFO LIST chunk (UTF-8 or Latin-1)
  - In AIFF files use an 'APPL' chunk with application ID 'IKEY' (UTF-8 only)
  - In ID3v2 use 'TXXX' with name 'Keywords' or 'Tags' (any encoding supported by tag)
  - In Vorbis/Xiph formats (OGG, FLAC, etc.) use 'KEYWORDS' or 'TAGS' (UTF-8)
  - In MP4 and other formats use custom frame 'Keywords' or 'Tags' (UTF-8)
  All user keywords are forwarded to the auto-tagging engine for further refinement as well.
- Pro: Support for alternatively named XMP chunks in WAVE/AIFF files.

Alpha 2313 (2024-12-16)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- Lots of small changes and fixes, updated several tag readers.

Usability:

- Pro: You can now middle-click one or more rows in the meta panel to make them priority metas
   for the duration of your Resonic session.
  The next time you switch the file priority metas are sorted to the top.
  Click any highlighted rows again to toggle their priority state.

User Interface:

- Sound system type in bottom right of status bar (e.g. WASAPI) is now underlined
   to indicate that it is currently open in Resonic. (095-6)
  Reminder: Click stop or press CTRL-W three times to quickly close and release the sound device.

Browser:

- Folder names that end with spaces on Windows cause all kinds of trouble.
  While folders with trailing spaces shouldn't be allowed Windows they technically are.
  For example, some archive programs may create folders that end with one or more spaces when unpacking
   archives created on other operating systems.
  Explorer will show them, and you'll be able to enter them, but:
  - Explorer fails on rename, source and target folders are the same, because it trims the spaces
  - Explorer fails on copy/move, source does no longer exist, because it trims the spaces
  - Cmd fails in general on all operations
  - PowerShell fails in general on all operations
  - Resonic can list files inside folders that end with spaces
  - Resonic is unable to list folders inside folders that end with spaces
  - Various programs will have trouble accessing them, or the files contained in them
  Resonic uses Explorer-compatible operating system routines and while there is no reliable way to work
   around this issue we decided to visualize the actual trailing spaces with middle dots and mark such folders
    in the browser with "trailing spaces".
  We also implemented the command 'Fix trailing spaces' which attempts to either remove or replace these spaces.
   It can be accessed from the right-click menu for such folders.
  It's really in your interest to try to remove trailing spaces from folder names on Windows whenever
   you encounter them. Resonic helps you with this task. (095-5)
    (reported: spice3d)

Alpha 2304 (2024-12-15)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- Channel picker buttons now colorized in yellow to stay with the Resonic color code of anything
   affecting sound, or being altering or lossy in any way, being yellow.
  Gotta do the level meters at some point too to highlight the fact that this is not pure.
- Mono mix button works post channel picker now. This is experimental code and currently honors
   the number of channels in the source material and using muted channels for output volume scaling.
  Please test this and see if the results are desirable. Alternate ideas always welcome.
   (suggested: emily)

Sound:

- Major improvements to the ResonicGM sound bank.
  All instruments were re-balanced, some instruments that were out of tune were fixed (especially chromatic
   percussion), some instruments were replaced with higher quality versions, and all instruments
    have now an added 3dB headroom.
- Factory sound bank content is now the same for both Resonic Pro and Player.
  However, the high-quality version included with Pro is replaced with a lower quality version
   in Player to reduce download size simply because most people who get the free version
    of Resonic simply don't care about MIDI rendering.

Metadata:

- Improved year-from-comments extraction for major tracked music formats.
  Affected files will be re-read automatically.

Alpha 2302 (2024-11-26)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- Updates some libraries to latest versions.
- Various small improvements.

Playback and Monitoring:

- Fixed channel order for 3-/5-/7-channel ALAC files
- Fixed channel order for 7-channel OPUS files (6.1 surround)
- Improved sound quality for MIDI playback
   when using the built-in Resonic sound bank (standard behavior),
    or modern soundfonts (SF2).
- Sound Blaster (SB) hardware filter and generator limits will be emulated
   when using oldskool soundfonts (SF2).
- Improved release behavior for overlaps of the same MIDI note
   (only the oldest note will be released).
- Support for SF2 soundfonts embedded in RIFF MIDI (RMID) files.
- Approximate support for Sound Blaster (SB) AWE32 filter NRPNs in MIDI playback.
- Doubled maximum number of MIDI playback voices to 200.
  If you're into "Black MIDI" content please report any unexpected behaviors.

Sound:

- Forcing channel rate for ASIO.
- Support for sample rate conversion with 32-bit integer ASIO formats
   that use 16/18/20/24-bit alignment.

Alpha 2298 (2024-06-11)
~~~~~~~~~~~~~~~~~~~~~~~

Integration:

- Removed Contour ShuttleXpress/ShuttleProV2 support.
  Reason: Partnership with Contour Design went stale a few years ago and the final SDK we've
   received back then started blocking Shuttle input in other programs while Resonic is running.
  We'd happily restart the partnership with a fresh integration if there is interest.
   (reported: cannibalox)

Browser:

- More reliable ALT-click in browser (scan subfolders shortcut).
  Over the last year several users reported ALT-click failing randomly. This might be tied to a hotfix
   installed by Windows Update, but this cannot really be confirmed.
  To be absolutely sure the code was reworked to be more compatible and reliable.
   (reported: d3mens, papa meelo)

Alpha 2269 (2024-05-27)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- This build has logging disabled and some startup speed tweaks.
  Let's see how it performs.
  Logging will be reenabled for the next build.
- Experimental secondary metadata thread, some artificial slow-downs. This should get metadata from disk/database
  faster, but might also stress out the HDD quite a bit more. Please test.
- Experimental changes in startup file/folder restore order. Please play a file in a folder with a large number
  of files, maybe even on a network drive, exit Resonic, restart Resonic, and see how it behaves. Is it better or worse?
- Each new Alpha version will now offer once to open the whatsnew.txt file.
  Every tester should be checking this file out for new builds.

Performance:

- Pro: New 'CACHE' operating mode, which is a hybrid between 'DETAIL' and 'BULLET' mode.
  In cache mode Resonic will use full detail where available, and show all available metadata for files
   that have already been scanned, but will never start metadata scans for new or modified files.
  This is very useful if you're working with a large amount of data that remains largely unchanged
   most of the time (e.g., on a network location) and you wish to scan it once and then leave it untouched.
  While this does not replace a future dedicated database it's a very handy feature for more control.
  You can cycle through operating modes using the 'DETAIL/CACHE/BULLET' combined button in the status bar.
  You can reset to detail mode (normal operation) with a middle-click on that button.
  You may cancel running metadata scans by clicking on the scanning animation in the status bar.

Alpha 2263 (2024-05-26)
~~~~~~~~~~~~~~~~~~~~~~~

User Interface:

- Pro: Browser items (root nodes) can now be hidden individually 'Menu | Browser'. (095-4)
  You may remove everything you don't actively use which in turn might speed up program
   startup depending on your setup and configured nodes.
  You could, for example, just leave your bookmarks visible.
- Pro: Drive letters can now be hidden individually via 'Menu | Browser'. (095-3)
  This might have a slight effect on startup/browser refresh speed as you may
   completely disable access to a slow-responding drive.
  This may be used on certain external drives to prevent wake-up-on-access.
  Note that Resonic will always show hidden drives for files you're trying to play on startup.
  You can use CTRL+H to toggle display of hidden drives in the browser.
  Drive information like display label is not available for hidden drives.

Alpha 2246 (2024-05-05)
~~~~~~~~~~~~~~~~~~~~~~~

Alpha Notes:

- The first Alpha build in ages.
  It's quite a big thing as the project was in the gutter since I'm back at it alone.
  I had to pick up the pieces and rework essential parts of the code.
  The complete licensing system is being replaced and most of the DRM was removed as the users
  have sent a clear message towards that idea in the polls I called.
  Alpha versions won't require a license anymore but are restricted to a small group of testers.
  A fully working bug reporting system was integrated.
  When the app crashes and you get the option to send a bug report, _please do_ and notify me on Discord!
  Please note that this is uploading to stuff.liqube.com so you need Internet access.
  The bug reports may be copied to the clipboard if the upload fails.
- Enabled 'Copy layout to clipboard' features for file list (right-click file list header).
- Fixed window size not being saved.
- Marked toggle light/dark theme as Pro only.
- Fixed @created date in file list layouts.
- Our beloved ResonicGM and ResonicProGM soundbanks have been reimplemented. Welcome back!
- Pro: Fixed two-digit tempos and certain keys not being detected in filenames.
- Highly experimental: While Resonic is running it remembers scroll positions and focused/active
   node (depending on single/double click mode) for each folder, even for subfolder scans separately (!),
    and restores it when the folder is opened next.
  Also, when you press F5 in a list the scroll position is not lost.
  There are definitely some glitches to be observed, give me your feedback!
- Some visual fixes to marker arrows and snapped line drawing.
- Fixed analyzer disappearing after seek and stop with right-click.
- Web radio streams display a "no waveform" message now.
- Worked around target rename glitches (now with input box) (jon vuri)
- Trying to set safety limits for CTRL+SHIFT+F (halves a selection).
- More visible marker lines (noticable on top of waveforms).
- Display fixes to size formatting (jon vuri).
- Known issue: toggling a column will not retain its order in the layout.
- Drag the active file (green) directly (no need to CTRL+CLICK it first.)
   This works independently from selected files. Let me know how it feels.
- Fade out button removed from Alpha builds (right-click stop button instead).
- Temporarily set default end action to 'Stop after current' instead of 'Play next'
   to see how users respond.
- Quite possibly fixed the 'file list occasionally not redrawing' issue, which typically
   occured when dragging the window across screens or during minimize/restore (try repro:
    WIN+D, restore from taskbar, 'Fit to Width' for columns must be enabled).
  Please confirm.
- Browser/file list font sizes still wrong during startup (depending on your dual head setup and Windows
   zoom setting), so please use the arrow menus in both browser and file list to select an appropriate
    font size that's workable.

Stability:

- Fixed several probably totally avoidable occasional crashes in the meta reader
   that might or might not ever happen.
  Frankly in this case though it would just crash. Hard.
- Pro: Slight reduction of memory use (~3MB per 100k displayed items).

Usability:

- Single-clicking the tray icon now toggles playback (play/pause) after a brief delay
   (typically your system's double-click delay.)
  Double-clicking the tray icon now toggles the main window.
- Added shortcuts for some transport basics:
  - 'Stop after the current file' (ALT+NUMPAD/)
  - 'Keep position' (CTRL+ALT+NUMPAD/)
  - Reminder: 'Loop' (NUMPAD/)
  - Reminder: 'Stop' (NUMPAD-0)
- Enabled state of 'Keep position' feature can now be remembered between sessions.
  Right-click the button and set it in the popup. (095-1)
- Added some shortcuts to their respective button tooltips.
- Retro-fitted word delete for all input boxes (CTRL-BACKSPACE),
   which includes rename dialogs and file list filter.
  If you've been using this shortcut in other software you know how big this is.
- New shortcuts to easily scroll the file list and browser using the keyboard:
  - SHIFT-CTRL-UP/DOWN to scroll vertically
  - SHIFT-CTRL-LEFT/RIGHT to scroll horizontally
- New shortcuts to manage folders in browser:
  - CTRL-C to copy the focused folder
  - CTRL-V to paste the clipboard contents into the focused folder
- Pro: Updated previous/next (UP/DOWN arrows) behavior for file list when file list filter
   is in 'Dim' mode (CTRL+F, button shows either 'dim' or 'hide').
  Resonic now skips disabled (i.e., filtered out and dimmed) items in the list accordingly
   and does not wrap around at the top/bottom of the list.
  Resonic also skips disabled items when selecting with SHIFT+UP/DOWN.
  Disabled items can still be played by clicking them.
- After a failed file rename (e.g., file already exists) you can open the rename dialog (F2)
   again and have the previously entered filename restored.
- After a successful file rename Resonic will try to restore and continue playback
   if the renamed file was previously playing.
  A previous paused state and position will also be restored if possible.
- Updated shortcuts for file list refresh to make more sense:
  - F5 refreshes the list contents
  - CTRL-F5 refreshes the list contents and rescans metadata for all items
  - SHIFT-F5 refreshes the and rescans metadata for the selected items
  - SHIFT-CTRL-F5 refreshes the complete list and rescans metadata for all items
- Pro: Changed CTRL+CLICK to resize selection to CTRL+SHIFT+CLICK.

User Interface:

- Reworked light theme for Resonic Player and Pro.
- Pro: New channel picker, below the transport bar.
  It shows all available audio channels in the current file, locator times, and time format.
  Right-click the transport bar and select it from the menu, or double-click the transport bar to toggle.
- Pro: Oscilloscope visualizer now scales vertically according to current gain.
- Activity indicator in status bar is now bigger, more visible, more clickable.
  Enjoy its glorious blockiness! It sure enjoys you clicking it to cancel any running
   subfolder and metadata scans.
- You can now control when the taskbar progress bar is shown on taskbar buttons (Windows 10),
   see 'Menu | Interface | Taskbar options'.
  - 'Disabled' never shows progress
  - 'Always visible' always show progress, even when Resonic is active
  - 'When in background' only shows progress when Resonic is in the background (default since 0.9.4)
  - 'When minimized' only shows progress when Resonic is actually minimized to tray
- Fixed 'Save', 'Restore', and display of user volume (right-click volume bar).
  You can now middle-click the volume bar to restore a previously saved user volume to quickly
   go back to a working volume you are comfortable with.
- New volume bar option 'Always show label' prevents auto-hide of the current db/% value.
   (right-click volume bar) (suggested: iFFO)
- Pro: Fixed level meter showing the same peak value for both channels of a stereo file.
   (reported: M. Tummino)
- Removed Twitter icon from status bar.
- More visible mute button, style prep for vectors.
- Several high DPI improvements, including browser icons (one of the most b0rked things in the win shell).

Playback and Monitoring:

- New advance mode 'Play sequentially + repeat list'.
  Plays the current file list endlessly, wrapping back to the top when done.
  Advance modes cycle with button presses between sequential, sequential + repeat list,
   and random. Note that the list can be properly shuffled via file list menu ('Shuffle list'). (095-2)
  You might have noticed that all advance mode symbols point down now, which honestly
   is the proper direction for them to point into as we're playing from top to bottom.
- Pro: Tweaked start/stop/pause/unpause for more snappy playback overall.
- Pro: Using advanced mixing for files with more than 6 channels.
- Pro: Slightly improved looping stability.
- Demoscene: New set of playback options for tracked music (MOD/XM/IT/S3M/MTM).
  - XMPlay-compatible sample interpolation:
   'Crisp' turns off interpolation for super crisp chiptune playback,
    'Medium' uses linear interpolation, or
     'Smooth' uses sinc interpolation for smooth but duller playback
  - XMPlay-compatible surround playback modes 1 and 2
  - Ramping (smoothes volume/pan changes and start of samples to avoid clicks):
   'None' to disable ramping (for special cases),
    'Normal' (FastTracker 2-compatible),
     'Sensitive' (for less aggressive ramping),
      'Automatic' (normal ramping for .xm files, sensitive ramping for the rest).
  - Compatbility mode for .mod playback can be:
   'XMPlay',
    'PT1' (ProTracker 1), or
     'FT2' (FastTracker 2)
  - Stereo separation for .mod playback can be:
   'Minimal',
    'Narrow' (FastTracker 2-compatible),
     'Medium' (linear), or
      'Full' (Amiga-compatible).
- Playback support for all basic stereo and multi-channel audio format
   content in Matroska (.mkv), Matroska 3D (.mk3d), and WebM (.webm) video files.
  No metadata support yet.
  Full surround-to-stereo downmixing for common channel configurations (also for MP4 videos).
- Playback support for DTS and some DTS-HD audio files (.dts, .dtshd).
  No metadata support yet.
  Explorer icon support is current not available.
- Playback support for mp3PRO audio files (.mp3pro).
  Full metadata is available.
  Explorer icon support is available, same icon as .mp3.
- Fixed playback of mono 24-bit ALAC (Apple Lossless) files.
- Network streaming playback of APE (Monkey's Audio) files.
- WavPack decoder updated to 5.7.0.
- FLAC decoder updated to libFlac 1.4.3, which supports 32-bit audio files.
- Opus decoder updated to libOpus 1.4, which uses SSE acceleration.
- Seeking improvements for WebM and Matroska files.
- Better reverb for rendered MIDI playback,
   and reverb/chorus levels raised to be closer to Roland/Yamaha standard.
- ResonicGM soundbank for MIDI rendering was shrunk by almost two megabytes
  Pro: ResonicProGM soundbank remains untouched
- Rebalanced MIDI FX volumes
- Better reverb for MIDI rendering

Musical Spectrum:

- Tweaked musical spectrum for better peak contrast.

Waveform:

- Pro: Fast-resize selections with CTRL+SHIFT+click.
  To resize a selection on either the left or the right side CTRL+SHIFT+click anywhere around
   the left or right locators (start/end of selection).
- Pro: Dynamic rearrangement of cue/marker/region labels.
  Before, labels would be rendered in single row and would either overlap or be cut off
   when there were multiple cues in the same place, or close by.
  Now, labels are placed in multiple rows in a way they can all be read.
- Pro: Fixed placement of makers and cues in MIDI music when rendered at sampling rates
   other than 44100 Hz.
- Pro: 'Fast Select' (selecting in waveform w/o SHIFT) can be toggled.

Browser:

- Middle-click a folder's arrow to fully collapse all of its subfolders.
- Fixed paste of certain paths into browser (e.g. ones that end in '..').
  Reminder: You can copy the browser's current path or the file list's current filenames
   to the clipboard with CTRL+SHIFT+C, use TAB to switch between them.
  Reminder: You can paste any full path string into the browser using CTRL+V,
   Resonic will then switch to that path automatically.
- Fixed display name inconsistencies for devices and network drives.
- New shortcuts when browser is focused:
  - CTRL+ENTER opens the selected folder in Explorer
  - SHIFT+CTRL+ENTER locates and selects the selected folder in Explorer
- New commands added to browser context menu:
  - Open folder in Explorer
  - Locate folder in Explorer
  - Fully collapse (all open folders below the current folder)

File List:

- Pro: Auto-shuffle feature randomizes the file list whenever the browser location changes
   right after sorting, even when you re-enter the same folder.
  I firmly believe in features that challenge or crush software linearity.
  While this feature seems pointless at first I urge you to give it a good chance next time
   you're browsing your samples or music files.
  It allows you to discover different things in different ways by breaking the habit of accessing
   the same files in the exact same way.
  Of course you can always shuffle the list manually with CTRL+ALT+SPACE and even use
   random playback with an already shuffled list.
- New columns for previous unexposed metadata.
  You can toggle them in the file list header's context menu.
  - 'Engineer' (in Artist)
  - 'Sub Song' (in Music/Statistics) for C64 SIDs and for future use
  - 'File Structure' (in Technical) shows you, for example, a RIFF file's structure (Pro only)
- Pro: Unscanned item symbols now use dimmed colors.
- Resonic now dynamically shows file types for which plugins are available.
  You can rename or delete unwanted plugin DLLs in Resonic's Resources/Plugins/ folder
   to effectively remove support for them.
  Note that this only works for formats that have no alternate playback method (e.g. through
   Windows Media Foundation), for example DSD or ALAC.
- File list now recognizes MPEG files with .m1a/.m2a extensions correctly.
  Explorer icon support is available, same icon as .mp1/.mp2.
- File list now recognizes M4A files with .m4p/.m4r/.ismv extensions correctly.
  Explorer icon support is available, same icon as .m4a.
- Pro: Ambisonics files with .amb (Ambisonics Wave) and .uhj (Ambisonics UHJ matrix-encoded
   Stereo Wave) extensions are recognized now.
  Full metadata is available.
  Explorer icon support is available, dedicated icon for .amb.
- Broadcast Wave files with .bwf extensions are recognized and played now.
  Full metadata is available.
  Explorer icon support is available, dedicated icon for .bwf.
- New column 'File Path' which represents the full path to an item (path + filename).
  Existing column 'Path' was renamed to 'Path Name'.
- Updated behavior for selecting files:
  - CTRL-CLICK an item in the file list to only select the clicked item,
   which is Resonic default behavior.
  - SHIFT-CTRL-CLICK an item in the file list to select the clicked item and additionally
   select the currently active item (e.g. playing file, which is closer to Windows Explorer behavior,
    except the concept of active vs. selected vs. focused item is foreign to Windows.
  The option 'Invert select behavior on CTRL click' allows you to flip the logic described here,
   which swaps the meaning of CTRL-CLICK and SHIFT-CTRL-CLICK.
    (find it in 'Menu | File List').
- Improved handling logic for selected items on drag & drop.
  Files will no longer start playing when dragged, and previously selected or focused,
   which could drive someone up the walls when sorting out a lot of files.
- Pro: New features to select and clear already played files in the current list.
   (find it in 'Menu | File List' or the file list's arrow menu).
  This is useful for cleaning up, moving, or deleting spotted content.
- The shortcut SHIFT-CTRL-DELETE now also works when there are no playable files left in the file list,
   in which case the browser will be instructed to delete its current folder.
- Long-standing file list bug fixed that would prevent changed items from being shown.
  This might slow down Resonic in special scenarios: let us know when it happens and what you were doing!
- Better compatibility with Explorer selecting behavior.
  You can now SHIFT-CLICK and drag a selection rectangle from unused areas (after last file, after last column)
   to add these files to your selection.
  You can do the same with CTRL-CLICK and drag to invert the selection you're drawing over.
   (suggested: papa meelo)
- New file list column management.
- Hold down ALT to start drawing a selection rectangle anywhere.
   This will also prevent any playback, no clicks will be forwarded to the file list.

Conversion:

- Pro: New 'Recycle Bin' batch target sends any files and folders it receives straight
   to the operating system's recycle bin.
  Right-click the targets panel to create a recycling target.
- Pro: Simplified creating a new target by right-click on an empty targets form.
- Pro: Gain control (next to volume bar) now affects audio extraction.
  All cropped, sliced, and processed, audio files created by Resonic will have the current
   gain applied, when in use.
  When 'Crop & Play' is used gain will be reset on playback automatically.
  What you hear is what you get in the output.
- Pro: Added '+' in front of positive semitone values to crop filenames.
- Pro: Send to target option now colorizes move targets.

Metadata:

- Pro: The 'Embedded Tech' column will now show the following additional bits of information that help
   you quickly determine what kind of metadata is contained in your file:
  - 'Clean' if a file does not contain any embedded metadata and is thus considered clean (or pure),
   which is extremely useful for finding out whether your file contains any tags, or not.
  The 'Clean' info bit is currently available for WAVE and MPEG files.
- Pro: Reading Deezer metadata, embedded lyrics, etc.
  Use the 'Embedded Tech' column to find out what's in your files.
- Demoscene: Sort your tracked music by year.
  The meta core now tries to extract the year of release from standard tracked music
   formats (MOD/XM/IT/S3M/MTM) and show it in the 'Recording Year' ('Year') file list column.
- Resonic now reads float tempos in beats per minute embedded in WAVE 'IBPM' chunks (INFO LIST).
- Pro: A large amount of additional Steinberg metadata (Mediabay, Cubase, Nuendo) is now
   being read, understood and shown in the meta panel, which includes a lots descriptive bits
    that will help categorize content on a metacore level.
  Good news, you'll be able to put your hard work to good use.
- Pro: Support for a set of Hercules DJUCED DJ software embedded metadata in
   .mp3/.ogg/.flac/etc. audio files, which includes user-created hot-cues and track start values.
  Cues for supported formats are now displayed on top of the waveform.
  A fast way to verify cue placement for the next DJ set directly in Resonic.
  Use the 'Embedded Tech' or 'Cues' file list columns to find out which files contain cues.
- Pro: Support for a large set of Native Instruments Traktor 2/3 DJ software embedded
   metadata in .mp3/.wav/.aiff files, including hot-cues and special rating values.
  Traktor metadata in .m4a/.mp4 is currently NOT supported.
  Traktor metadata in formats that use VorbisComment (.flac, .ogg, etc.) is NOT supported.
- Fixed rare overflow errors with files containing certain broken metadata.
- Support for iTunes parental advisory flags.
- Unicode flats and sharps are now supported in inital keys.
  The musical key column (a generalized interpretation of the inital key) shown in Resonic will now
   always use these special symbols rather than an ordinary 'b' and '#'.
- First batch of Cubase metadata improvements (thanks: grada for gigs worth of example files!)
- File detection confidence improvements/misdetect fixes.
- Demoscene: Metadata support for AHX modules (Abyss Highest Experience Module).
  - Title
  - Comments
  - Music Sample Count
  - Music Pattern Count
  - Software (AHX version)
  - Year (guessed from comments like other tracked music)
- Demoscene: Improved year extraction/guess from tracked music comments.
  The year will be shown in the 'Year' column.
  Curently supported for MOD/XM/IT/S3M/STM/AHX.

Filtering:

- Much faster file list filtering (4-6x speed) when using plain text patterns,
   or complex combinations of plain text include/exclude patterns.
  The speed-ups are automatically applied by the filter optimizer.
- Pro: Fuzzy string filtering.
  Append a tilde to any filter term, e.g. 'kick~' to make use of it,
   which also works when using quoted terms, or any of the other filter features.
- Pro: Filter term interpretation prefixes (e.g. 'fuzz:kick').
  'wild:' forces a wildcard pattern
  'fuzz:' forces a naive fuzzy search pattern (same as appending a tilde to a word)
  'norm:' forces a naive normalized search pattern (caseless, symbols and spaces removed)
  'bi:'   forces a fast search pattern (for short/medium plain text)
  'bif:'  forces a fast fuzzy search pattern (for short/medium plain text)
  These are subject to be renamed in future updates.

Beta 0.9.4 (2021-08-17)
~~~~~~~~~~~~~~~~~~~~~~~

This is a major release, despite its version number, and contains big improvements,
 numerous new features, and countless essential fixes.
We have dramatically improved Resonic startup speed (up to 20x faster) and High DPI/multi-screen support,
 added a powerful new file list filter for all versions, but also reworked the file list
  to be more responsive, the column system to be more flexible, and the browser to do things a bit faster.
The new refinement filter allows matching whole words, exact phrases, wildcards, including
 and excluding patterns, but any combination of these in one go is also possible.
In Resonic Pro 'Target' copy and move issues were fixed, waveform 'Fast Select' (without SHIFT+X) (without SHIFT)
 is now a thing, the 'Prepare and pause' mode was made more reliable, leading/trailing slices
  for slice export options were added, to name a few.
Reaper users get to enjoy our pretty unique 'Copy as Reaper media' feature for pasting clip references,
 with Resonic Pro's current playback settings applied, directly into their DAW of choice.

Beta Notes:

- Fix settings dialog being bigger than screen (on 4K 300% zoom).
- Fixed internal item path getting corrupted after copy (reported a few times).
- Fixed ID issue on drag copy/move of files to a folder.
- Temporarily re-enabled startup logging for Beta builds.
   Log files are either written to the .exe location, or to your Documents/Resonic/ folder,
    and are called 'Resonic.log' and 'Resonic.previous.log'.
  Builds running with logging will show '[LOG]' in the main window title.
- Fixed status message when changing default device.
- (Hopefully) Fixed Resonic not properly being restored on Play/Browse in Resonic (drip)
- Fixed bookmark side effects of new ID system by upgrading old IDs (sirdwyck)
- Some UI fonts (header, etc.) should now look as intended, narrow and less obnoxious (Zennon)
- Fixed pitch 'Frequency' changes (via drop down) not working (stephan_)
- Fixed last used drive showing up twice (new IDs issue) (sirdwyck, Loopws)
- Switched to new cache ID generation code that works for files/folders/URLs/etc.
  This is a required breaking change and had to be done prior to release. Bookmarks continue to function,
  nothing else should be affected, all metadata will be re-read.
- Fixed sort column/direction not being restored.
- Fixed 'Show level meter' on visualization button not doing anything (drip).
- Fixed little button menu indicator arrows not being scaled, also some of them missing (drip).
- Status bar reads "FIND IN LIST" for the time being to invoke the filter, and to provide
   and instant answer to one of the most asked questions.
- Metadata read speed improvements.

Remarks:

- The last two years were challenging, but which years aren't. This time though it feels different.
  It feels like it hasn't ended yet, it's merciless and ongoing, relentless and punishing in ways
   we haven't experienced before.
  In late 2019, a week prior to the planned release, a lighting storm fried our gear which was a major setback.
  Back then we thought of it as the icing on the demotivational cake, but you all know what came next.
  A year into it we've started losing close family members, but the fact that it wasn't due to the pandemic
   didn't really lighten the baggage that came with it.
  Resilience and focus seem to be the most relevant words these days.
  If you ever thought about supporting the project, now is the time to buy us a pizza, or three,
   a bag of roasted coffee beans, a new computer, a holiday, a car, a villa, or simply Resonic Pro licenses
    for yourself, your friends, or your company, but feel free to do all of the above in any order or at the same time.
- Button icons currently still use pixel graphics and don't scale, which is mainly noticable
   if you're using Windows on a zoom setting of 150% or above.
  We'll be addressing this in the next version.
- Across the program 'Preferences' are now called 'Settings'. The preferences file was renamed.
- In portable versions 'ResonicBoot.ini' is now called 'ResonicBoot.sample.ini' to serve
   as a template in making your own and to make sure your own is not overwritten when
    extracting a new build.
- A reminder that while the free Resonic Player will play up to 8 channels and 96 kHz
   Resonic Pro has no channel limit and can play sample rates as high as your hardware can handle.

Performance:

- Much more responsive toggling of the main window using tray icon clicks.
- We've done what we can for now to ensure mapped drive letters for network shares (NAS, VPN, etc.)
   will neither block startup nor full browser refreshes, which for disconnected shares could
    in some extreme cases take up to a minute per drive.
  This is an ongoing Windows-related issue that needs constant attention and workarounds
   for various Windows versions, please keep reporting.
  Trying to expand a disconnected share may still take up to 30 seconds in the background.
   (thanks: Mixmaster)
- Dramatically improved startup speed (up to 20x faster) through a series of tweaks
   and reworks across all parts of the program.
- Much improved device listing and access speed, which also affects startup speed in certain
   situations and on certain system, especially with slow-to-respond drivers.
    (thanks: gloom, and several others)
- Reduced visual glitches during application startup, especially on multi-monitor systems.

Stability:

- Fixed an issue that could cause Target operations to fail on Windows 7.
- Fixed application freezes on random track playback (automatic advance or manual random)
   on certain AMD Ryzen 3000 series CPUs with broken microcode.
  All versions of Resonic after 0.7.2 are affected.
  Consider updating your BIOS to the latest AGESA (1.0.0.4+ is fine) as soon as possible
   to fix this, and to avoid running into problems with other software.
    (thanks: Andreasvb)
- Fixed folder monitoring related crash bugs in the browser.
  One bug in particular occasionally caused an endless ocean of message boxes flooding all over your
   screen in seemingly random but mathematically carefully determined places, creating unprecedented
    generative digital art in the process. A thing of real beauty: boxes, buttons, confusing messages,
     red 'X' symbols, everywhere, reminiscent of Windows 95. Nostalgic, but it had to go.

Usability:

- File and folder rename operations are now case-sensitive.
- ALT-click the 'Next' button to play a random file (same as ALT+SPACE.)
- ALT+click the 'Stop' button to fade out and stop (6 seconds.)
- Right click header filename to 'Copy text to clipboard'.
- Last-used settings (CTRL+P) page is now remembered.
- Loop toggle shortcut was changed to ALT+L (in addition to NUMPAD-DIVIDE).
- You can now double-click the empty area behind the 'File List' tab to maximize the middle panel,
   thus making the file list wider.
  Double-click again to restore the previous state of the left/right panels.
- Pro: You can now double-click the empty area behind the right sidebar's tabs (targets/meta) to make
   the panel wider, while another double-click will restore your previous width.
  Note that this also works for the left sidebar (browser) in exactly the same way.
- Passive colors for active file/folder and selections in file list and browser
   (colors change depending on file list/browser focus.)
- Bookmarks that point to missing paths ('offline') can now be removed.
- Fixed bookmarks pointing to deleted folders/ejected devices going invisible until app restart.
- Stop mode button ('Stop after current') (red line symbol) is now activated by default.
   (thanks: participants of the FB group poll)
- Aside from clearing the current selection ESC now also switches back to the file list filter if open.
- Pro: 'Crop selection to new file' commands have been added to waveform popup
- Pro: Gain handling improved, global hotkey support, and shortcuts:
  CTRL+ALT+NUMPAD-PLUS (gain up one decibel)
  CTRL+ALT+NUMPAD-MINUS (gain down one decibel)
  CTRL+ALT+NUMPAD-MULTIPLY (gain reset)
- Pro: Vertical zoom handling improved, global hotkey support, and shortcuts:
  CTRL+SHIFT+NUMPAD-PLUS (vertical scale up)
  CTRL+SHIFT+NUMPAD-MINUS (vertical scale down)
  CTRL+SHIFT+NUMPAD-MULTIPLY (vertical scale reset)
   (suggested: J-P. Belliard)
- 'Locate active file in browser/playlist' feature (click on header filename, or locate button)
   will now only switch directories if absolutely necessary, preserving multi-folder scans.
  Also, you can now use the shortcut CTRL+SHIFT+ALT+NUMPAD-MULTIPLY anywhere.
- Dim with SPACE (holding down the SPACE bar to temporarily dim the volume) is now disabled
   by default in all versions in favor of faster response times.
  It can be reenabled from the play button context menu ('Enable dim on space').
- Pro: Added 'QWERTZ with umlauts' to keyboard layout selection for instant mapping (slice triggers),
   which extends the standard QWERTZ layout with the three German umlauts (Ü, Ö, Ä.)
  Click the marker/cue button and see 'Keyboard trigger settings'.
- Pro: 'Create new target' now always visible in Targets context menu.
  New targets will be inserted after the right-clicked target.
   (suggested: Nettles)

Integration:

- Fixed a bug that prevented some removable drives from being ejected while Resonic was running. (1706)
   (reported: T. Helzle)
- Fixed several rare drag & drop issues.
- Pro: 'Copy as Reaper media' and 'Copy as Reaper media (section)' from the selection popup menu
   for use with Cockos Reaper (requires version 5.974, or higher.) (094-1)
  This command copies the current selection as a Reaper media clip to the clipboard,
   which can then be pasted into the Reaper timeline as a reference to the original media file
    rather than as a new audio file.
  These current Resonic settings are translated and affect the generated Reaper clip:
   selection, loop, pitch, trim volume, mute.
  So to create a looping but muted Reaper clip, in Resonic create a loop and mute the volume
   first, then use 'Copy as Reaper media', for example.
  Currently supports: wav, aiff, mp3, ogg, flac, opus, and wv.
   (thanks: Justin at Cockos for hearing us)
- Allow Resonic to be started minimized or maximized via shortcut overrides. This also
   fixes a bug that could cause the main window to not appear. (reported: Luke)
- You can now choose whether Resonic should by default automatically advance to the next file
   or stop playback after playing the first file when opening a file or folder directly via shell,
    i.e. via Explorer menus or via command-line parameters.
  Separate settings are available for files and for folders.
  The existing command-line parameters "--advance" and "--no-advance" will override these settings.
  See 'Menu | Advanced | Explorer & Command Line'. (reported: Luke)
- Refreshed all Explorer icons (Setup version only) with better contrast, sharpness,
   and some new graphical elements.
  Each icon now has a square 32x32 version which shows up (e.g.) in Explorer's "Content" view,
   to ensure the name of the file format is well-readable.
  The 16x16/24x24 versions that show up in (e.g.) Explorer's "Details", "List", and "Small Icons" views
   have been replaced with simple squares that use the same color scheme as the Resonic file list,
    representing lossless (blue), lossy (orange), music (green), video (purple), and rex (deep blue) files.
- Fixed 'Browse/Play with Resonic' not working when used via folder background context menus.
- Resonic now shows an '[E]' in the title bar when it's run with elevated privileges (usually as Admin).
  This is useful for troubleshooting Drag & Drop issues that may stem from using a mix of elevated
   and non-elevated applications.
- Improved both install/uninstall sides of the installer (MSI setup), and fixed play/browse shell icons
   not being shown in context menus

User Interface:

- Pro: Fixed white flashes during waveform resize when using dark skin.
- Tray icon can now be disabled (see 'Menu | Interface | Window options').
   Note that this will also disable any tray related features like minimize or close to tray.
    (suggested: O. Mironov)
- Several 'High DPI' improvements (mainly related to font sizes).
  Including header and info bars, volume bar, level meter, visualizations (waveform, etc.),
   time display, and drop-down font sizes.
- Improved reliability of font size and display density changes (for file list and browser),
   fine-tuned spacings, and added additional presets for both.
- Pro: Fixed failing drag & drop of waveform selections and header filenames onto 'Decode'
   and 'Process' targets.
- Splash screen goes away faster now when the main application is fully loaded.
- More visible blue tab dividers when a section (left/middle/right) is focused.
- Main window restores faster from tray when maximized, related glitches have been fixed.
- Pro: Fixed '0 dBFS' level meter preset.
- New option for full transport time display (i.e. HH:MM:SS,MSEC) instead of compact default.
- Refreshed font for transport time display and other monospace content.
- Bigger and bolder input boxes where applicable and actually useful.
- Pro: Selection and marker menus added to main menu for better overview.
- Many light and dark theme tweaks to loop and marker visibility, scrollbars, list backgrounds,
   waveform shape, silence line, and buttons.
- Dimmed subtitles in meta panel for better focus. (094-5)
- List of user sound fonts in menus is now sorted.
- Type of tracker module now shown in info bar for MO3 files, e.g. "Module (XM)".
- Pro: Extraction progress mouse cursor (when portions of audio are dragged out and mouse button
   is held down) is now green to be more visible, and more consistent with the status bar's
    green progress bar also used during decoding, processing, extracting.
- Scrollbar buttons are now hidden by default.
  If you really need them you can reenable them in 'Menu | Interface | Control options'.
- Fixed initial splash screen size on secondary screens.
- Fixed splash screen not always opening on the last-used screen as expected.
- Play/Pause button glyph logic inverted by popular request,
   i.e. when playing the combined Play/Pause button will show '||', when paused it will show '>'.
  Be reminded that you can unlink the button into two separate ones with a right-click.
  A graphics update bug related to unlinking these buttons was fixed.
- New 'Minimal' (4:20) and 'Tight' (4:20.5) time display modes hide or reduce milliseconds,
   in addition to 'Compact' (4:20.500), and 'Full' in Resonic Pro.
- Time format now uses comma (,) instead of period (.) as its milliseconds separator.
  This applies to the time display, the file list, and the meta panel.
- Combinations of SHIFT and letter keys can no longer be used as global hotkeys as they
   override system-wide uppercase letters if accidentally used. (1574)
    (reported: Cooly)

Playback and Monitoring:

- Pro: ENTER now plays from the selection start if there is a selection (allows for loop retriggers.)
  If there is no selection playback will restart from the beginning of the file as usual. (094-3)
   (thanks: participants of the FB group poll)
- Pro: 'Pause at end of slice' option for auditioning temporary slices via letter keys
   added to marker buton menu (next to A-B button.)
- Fixed an issue with very large MP4/M4A files, usually containing many hours of audio, that would
   freeze up Resonic for several seconds or permanently while generating glitchy sound.
  This occured either when seeking past a certain file size or time, or when playing past that boundary.
   (reported: P. Landau)
- New option 'Follow default device (WASAPI)' in sound settings lets you change how Resonic
   follows the current system standard playback device.
  In previous versions the device was automatically changed, and it was not possible to lock Resonic
   to one specific WASAPI playback device, regardless of the system settings.
  This behavior is now disabled by default, but can be toggled, or you pick the new 'Default Output Device'.
- 'Default Output Device' is now selectable for WASAPI output. It will always try to stick
   to the current system playback device, whichever one is currently being used by the system.
  Using this will override 'Follow default device'.
- Pro: Playback of files with high sample rates (>192 kHz, e.g. 384 kHz) (WAV, FLAC, etc.)
- Improved 'Keep position' handling on automatic track advance and in a few other scenarios.
  You can now delete files and play the next one without losing the starting position.
- Pro: Made launch mode 'Prepare and pause' more predictable.
  When this mode is active files will load and pause, but only start playing on ENTER or seek click.
  When the next/previous/a random file is played (manually, or automatically through track advance)
   it will also load and pause only, but never start playing unexpectedly.
  This mode is mainly intended for special use, or if you simply prefer working like this,
   and can be combined with 'Double Click Mode' (DCM).
- Pro: A few slice rendering settings added to marker button menu.
  Uncheck 'Always create leading slice' to not render the first slice to a new file unless you have
   explicitly created a slice marker at the beginning of the file.
  Uncheck 'Always create trailing slice' to not render the portion after the last slice marker
   to a new file unless you have explicitly created a slice marker at the end of the file.
  You can set the 'Number of digits' for the filename as well.
   (suggested: G. Green) (094-2)
- Pro: Pitch settings are now applied directly and without delay,
   fixing short sound playback on high pitch settings (potential glitchy transient at beginning of sound.)
- Pro: Pitch no longer resets on ENTER when 'Remember pitch' is deactivated.
- Pro: More responsive retriggering of the current sound file (on ENTER, SPACE, click.)
- Faster fade out when pressing the stop button. Can be disabled in Pro.
- Pro: 'Free audio streams on stop' option always unloads files when a stop command is received.
   It can be activated from the stop button context menu.
- Support for Ogg FLAC files, i.e. compressed FLAC data stored in an Ogg container.
- Opus and Speex files with .ogg extensions are now detected and played back.
- Experimental: Custom dim volume reduction in dBFS.
  Set 'transport/dim/dbfs' in settings file to -1..-50 (anything below -50 acts as mute).
   (suggested: tomtrigger)
- The file content is now always checked in a second pass if the file format cannot be determined
   in the first pass. This should cover the detection of formats with wrong file extensions.
- WavPack decoder updated to 5.3.0
- Fixed filename not being shown on unplayable files (format errors.)
- Fixed track advance not stopping after pressing 'Stop' in some cases, e.g. when trying
   to play several unplayable files (format errors.)

Waveform:

- Pro: 'Fast Select' lets you create a selection without holding down SHIFT.
  To draw a selection left-click into waveform and move the mouse while holding down the button.
  For a popup menu right-click the selection.
  To clear the selection quickly use SHIFT+right-click anywhere.
  Fast Select is disabled for the first few moments after switching files to allow for seeking,
   and is disabled for the first few moments after seeking.
  You can toggle Fast Select via the 'Selection' menu, or the A-B button right-click menu.
- Pro: You can now right-click waveform selections to open a popup menu that provides
   you with some additional commands.
- Pro: Ruler, cues and markers are now shown immediately while scanning,
   which is especially noticable for longer files.
  They may move around a bit though if the current file's total playback time is still being updated,
   e.g. when scanning certain VBR (variable bit-rate) files.
- Pro: Fixed visual issue with selections that go all the way to the left.
- Pro: More visible cue/marker/region labels

Analyzer:

- 'Solid background' option now available to Player users.

Browser:

- Fixed very rare issue where ALT+click to scan all subfolders did nothing in the browser
   on certain systems.
- Active folder is now painted in a blue shade (instead of green) when it is also currently selected.
  Important when using the keyboard for visual verification of the selected item.
- Browser expand/collapse buttons (arrows) and indentation now scale with the font size.
- Fixed incorrect active item path highlight.
- Faster auto-scrolling and auto-expanding folders while dragging onto browser.
- To prevent accidentally copying/moving folders in the browser we introduce 'Safe drag & drop' options
   that can be found in the browser menu (arrow, or via main menu).
  With 'Drop with Ctrl/Shift only' active you can only drop a dragged folder while holding down
   either CTRL or SHIFT, copy or move respectively, at the same time.
  This is the recommended option to begin with and is enabled by default
  With 'Drag with Ctrl/Shift only' active you can only start a drag while holding these keys down,
   so without CTRL or SHIFT it'll feel like Drag & Drop within the browser is deactivated.
  Try any combination of these two options and use whatever feels best.
  For usability's sake these settings do not affect drops coming from the file list
   or other applications, only drag & drop within the browser
- Bookmark nodes can no longer accidentally be dragged into each other (moved/copied)
   without holding down CTRL or SHIFT. (1567)
    (suggested: tomtrigger)
- 'Show hidden folders' (CTRL+H) is now also available from the arrow menu and is remembered
   between sessions.
- Full file and folder paths (in text form!) can now be pasted (CTRL+V) directly into the browser
   when it is focused. This will make the browser switch to the location.
  You can, for example CTRL+C the full path displayed in a Windows Explorer window and then
   CTRL+V it into Resonic's browser.
  You can also use CTRL+SHIFT+C in Resonic's browser to copy the path of the current folder
   to the clipboard so that it can then be pasted in another application.
- Fixed 'New folder...' not being shown for drive roots like C:\
   (reported: Dj Zhivko)
- Refresh now centers the active folder in the list.
- Fixed refresh behavior and shortcuts.
  When the browser is active F5 now only refreshes the focused folder, as expected,
   and CTRL+F5 refreshes both browser and file list.
    (reported: J. Rajavuori)

File List:

- The file list and its filter (CTRL+F) have been reworked to be less blocking for better
   responsiveness, and to handle large amounts of files more reliably.
  This is a major rework so please make sure you report any glitches as soon as they appear.
- Fixed a bug that could cause files to disappear from the file list when renaming them
   outside of Resonic.
- Fixed sort column visual glitches when scrolling horizontally.
- File list header font now scales according to the font size/spacing setting.
- The 'Shuffle list' feature (CTRL+ALT+SPACE) will now always keep the active item, if there is one,
   at the top of the list allowing shuffled sequential playback from there.
- Pro: Fixed 'Send to Target' always copying files to 'Move' targets.
   (reported: P. H. Bushaw)
- Pro: Fixed file list position being lost after a file is sent to a 'Move' target and disappears from the list.
   (reported: P. H. Bushaw)
- Pro: The 'Send to Target' menu now indicates the type of target (e.g. 'Move')
   and uses accelerator keys (1..9, etc.) for quick access.
- 'Sticky selections' are now now disabled by default to match the standard behavior of other
   software, but can anytime be toggled via 'Menu | File List | Sticky selections',
    or via the file list arrow menu.
- ENTER will now start playback at first file in list if all else fails.
- Pro: Improved 'Export file list', which can now be found in 'Copy special'.
- 'Restore default widths' in the column context menu applies default column widths to your
   currently visible columns, which can be useful if your widths went out of whack for some
    reason or you just want to restore them to some reasonable values.
  Your custom column visibility or order remains untouched.
- Experimental: File shortcut resolver, resolves .lnk files in the file list,
   supports environment variables in shortcut path.
  Set 'elements/file_list/resolve_shortcuts' in settings file to 0 or 1.
- Fixed 'Refresh list and metadata' context menu item not refreshing metadata,
   while the shortcut (CTRL+ALT+F5) was working properly.
- New 'Refresh selected' (CTRL+F5) command refreshes selected items, including metadata.
- CTRL+ENTER now opens the current folder in Explorer even without selected files.
- Name of clicked column (to quick-toggle column) and 'Reset to unsorted' (to reset of sorting by column)
   moved to the top of the column context menu.

Sound:

- Pro: Dithering option (TPDF) for ASIO output, when converting float to integer samples.
- When playing through WASAPI Resonic now registers itself in the 'Media' category,
   i.e. appropriate signal processing modes may be applied by sound drivers.
- "Raw mode" option (WASAPI only) lets you bypass all Windows sound driver sound enhancements.
- Fade out and stop (right-click the 'Stop' button) now uses more musical-sounding
   fades (logarithmic rather than linear).
  Added additional slow fades: 30/45 seconds and 1/2/3/5/10/15 minutes.
  The very slow fades are useful when playing mixes, ambient music, etc.
  Note that ongoing fades stop on track change.

Conversion:

- Pro: All Targets can now be removed at once via context menu (094-4)
   (suggested: A. Maire)
- Improved wording on target removal to be more clear.
   (suggested: drip)

Metadata:

- Pro: Fixed 'Origin Time' (BWF time reference) being displayed wrong in some cases (>12h typically).
   (reported: V. Chaga)
- Pro: APEv1 and APEv2 tags are now reported separately in 'Embedded Tech'.
- Pro: Consistent display of Windows/Unix style line breaks in multi-line text metadata
   (e.g. descriptions) in meta panel
- Pro: Full display support for iXML 2.0 location types, location times, and take types,
   as well as other iXML-related improvements.
- Pro: Initial key metadata is now reported as free-form in a separate column ('Initial Key'),
   in addition to the 'Musical Key' column which continues to be the initial key in musical format.
    (thanks: wayfinder)
- Pro: 'Open Key' notation support.
  Will show up in 'Initial Key' column, and in 'Musical Key' column as a musical translation.
  The 'Open Key' notation is in use by major DJ software like Traktor or Rekordbox.
  Note that 'Camelot' notation will never be displayed nor written or used in any other way or form
   due to bizarre licensing restrictions.
- A more generic 'Year' column now presents the year found in either the recording date,
   the release date, or the original date, in that order.
- Pro: General audio properties sorted down in meta panel.
- Pro: Improved metadata support (bits of information read) for MP4, M4A, M4B, M4V, and ALAC files,
   and as an extra iTunes media types are shown in the meta panel.
- Pro: Audio files with ACID Next content are now recognized.
- Fixed potential freeze when reading certain incomplete MP3 files.
- Metadata support for AAC files (raw transport streams with ADTS headers), including sample rate,
   channel count, bitrate, duration, audio flags (e.g. 'Joint Stereo'), MPEG audio object type,
    MPEG version, content flags (protected/private/original/copyright), channels, and channel layout.
  Duration is an estimate in favor of overall performance (only a portion of the file is scanned),
   and thus might be inaccurate in some cases.
- Pro: Correctly interpreting Reaper loop label markers.
  Reaper stores additional markers for loop start labels inside Wave files. Our tests show that
   a lot of big name software, including Sound Forge 13 and WaveLab, misinterpret (on load) and
    break (on save) these markers.
  We keep all research, so get in touch or visit our Discord if you need to know more.
  A few words on editing files: https://resonic.at/faq#onediting
- Pro: Several new bits of metadata information are now shown in the meta panel, including many date
   and time pairs, where available:
  - 'Producer Name'
  - 'Manufacturer Name' (WAVE, iXML, Soundminer, Steinberg)
  - 'Origination Date' (combined BWF origination date and time)
  - 'File UID' (iXML, etc.)
  - 'Set/Family UID' (iXML, etc.)
  - 'UBits' (iXML userbits, for compatibility)
  - 'Original Filename'
  - 'File Path (Soundminer)' (original Soundminer file path)
  - 'Software Name' (now recognizes Soundminer)
  - 'Location Types' (iXML 2.0)
  - 'Location Times' (iXML 2.0)
  - 'Take Types' (iXML 2.0)
  - 'Recording Location'
  - 'Recording Device' (improvements)
  - 'Microphones' (improvements)
  - 'Start Date' (broadcast start date for CART waves)
  - 'End Date' (broadcast end date for CART waves)
  - 'Creation Date' (WAVE)
  - 'Purchase Date' (MP4)
  - 'Release/Retail Date' (ID3, Soundminer, Scott Studios SS32, Wide Orbit, generic)
  - 'Original Date' (ID3, MP4, WMA, Olympus, Apple Finder, generic)
  - 'Recording Date' (ID3, WMA, generic)
  - 'Ripping Date' (generic)
  - 'Encoding Date' (ID3, generic)
  - 'Tagging Date' (ID3, generic)
  - 'BWF Version'
  - 'iXML Version'
  - 'CART Version'
  - 'APE Version'
  - 'APETAG Version'
  - 'Wave Format Extensible GUID'
- Pro: Now also reads time signature and tempo embedded into files by Apple Finder.
   All the other basics are being read already.
- Record Label (the company/entity that released a work) is now handled separately from
   Publisher (the company/entity that published a work) in all file formats.
- Pro: Resonic now reads the entire iTunes metadata specification in MP4 files,
   covers will be handled separately, adding these new ones in this update:
  - 'Subtitle'
  - 'Grouping'
  - 'Pre-defined Genre'
  - 'Encoder Settings' (CDEC)
  - 'Sound Check' normalization information
  - 'Original Artist' (previously shown as Composer)
  - 'Director'
  - 'Art Director'
  - 'Cinematographer' (Directory of Photography)
  - 'Producer'
  - 'Executive Producer'
  - 'Arranger'
  - 'Conductor'
  - 'Record Label' (Record Company, previously as Publisher)
  - 'Publisher' (iTunes standard + non-standard 3rd party fabrications)
  - 'Photogram Rights' (Produced Notice)
  - 'Description' (Song Description)
  - 'Liner Notes' (Album Notes)
  - 'Engineer' (Sound Engineer)
  - 'Soloist'
  - 'Credits' (Source Content Credits)
  - 'Acknowledgements' (Copyright)
  - 'Thanks/Dedications' (Artist) (shown as Acknowledgements)
  - 'Related URL' (Online Extras URL)
- Vinyl track numbers and counts are being parsed (FLAC, etc.).
  Side A is intepreted as 101 102 etc., side B as 201 202 etc., and so on.
- Improved textual metadata parsing for RIFF WAVE files (UTF8, foreign characters).
- Fixed metadata scan taking a long time when encountering buggy .ogg files.
   (reported: wayfinder)
- Pro: Ableton Content (packed/encrypted) is now detected by the meta core, check meta panel.
   (reported: sirdwyck)
- Pro: Fixed a bug that would potentially lead to crashes during scans of WAV/AIFF files that
   contain broken iXML metadata describing the embedded channels.
- Pro: AES CART chunk timers INT1 and SEG1 are no longer just triggers (so far displayed
   in waveform as 'TRG'), but are interpreted and displayed as 'Intro' and 'Segue'.
- Pro: Chapters are now being read and displayed in the waveform as 'Chapter'. If a chapter title
   is available it will be shown as well.
  Currently supported are:
  - 'Chapter' frames in ID3v2 tags (MP3, WAV, etc.)
  - 'CHAPTERxxx' metas with timecode in Xiph Comment/Vorbis tags (FLAC, OPUS, OGG, etc.)
   as well as in APE tags (APE, etc.)
- Pro: The 'Embedded Tech' column will now show the following additional bits of information that help
   you quickly determine what kind of metadata is contained in your file:
  - 'Cue' if a file contains at least one cue that has no length (start position only),
   which could be markers, transients, intro, outro, triggers, slices, etc.
  - 'Region' if a file contains at least one cue that has a length (start position + end position),
   which could be actual regions, sampler loops, chapters, etc.
  - 'Picture' if a file contains exactly one embedded/attached picture
  - 'Pictures' if a file contains exactly more than one embedded/attached picture
  - 'Xiph' if a file contains a Xiph Comment (Vorbis tags)
  - 'Ape' if a file contains an APE tag
  - 'Lyrics' if a file contains lyrics text (MIDI, MP3, FLAC, etc.)
- Pro: Resonic now reads iXML metadata embedded in FLAC files.
  It was introduced in Reaper 6.10, but we had to implement workarounds to handle broken content.
  In case Cockos is reading:
  - You write the application block magic twice ("iXMLiXML") - it's 32 bits per spec
  - Your XML structure is malformed as you end on "</BWFXML></BEXT>", but BWFXML is the root element
- Pro: Support for additional Steinberg-specific (non-standard) iXML metadata:
  - 'Library Name' (Media Library)
  - 'Library Manufacturer' (Media Library Manufacturer) (shown as 'Manufacturer')
  - 'Artist' (Media Artist)
  - 'Comment' (Media Comment)
  - 'Category' (Media Post Category)
- WMA codecs (1/2/9 Pro/9 Lossless) are now detected properly and WMA lossless files are displayed
   with the correct lossless color markings (blue).
  The codec name and encoder settings are now also read from WMA files and displayed in the meta panel.
   (reported: patriceG)
- Better handling of invalid float metadata, e.g. broken BPM values written by dBpoweramp,
   that could lead to unexpected application crashes.
    (reported: sirdwyck)
- Fixed occasional application crashes that occured when certain folders that contain files cached
   by much older versions of Resonic were opened.
    (reported: M. Senfft)
- Pro: BWF descriptions are now read from the "<Bwav_indexes>" element in aXML (additional XML) chunks
   embedded in RIFF WAVE files. (reported: A. Menshikov)
  According to game audio users this content is written by Basehead and often cannot be found
   anywhere else in the WAVE file, not even in the BWF chunk.
  Resonic now displays this information in the 'Description' column and the meta panel and future
   versions will be able to pluck apart and search this content, which will especially be interesting
    in 'Sound FX Mode', where the Resonic Meta Core is optimized for SFX.
- Resonic now detects incorrect durations in (now obsolete) ID3v2 'TLEN' fields and ignores them,
   which in some cases lead to incorrect playback times to be displayed (even though Resonic
    does not require this particular information.)
  Fellow developers, 'TLEN' fields are supposed to hold milliseconds (e.g. 145267), but could
   sometimes contain seconds (e.g. 145), so if you're reading this field check for low values
    or ignore it, and if you're writing seconds into this field, fix your software!
  (reported: Snapuman)
- Unicode flats and sharps in initial key metadata are now supported.
- Handling WWW in Vorbis/APE tags as user URL and added support for numerous other WWW* variations
   that should cover all of the most commonly used user URLs.
    (suggested: drip)
- Pro: Improved metadata support for Scott Studios (SS32) and Wide Orbit Wave files,
   used in radio automation and broadcast systems.
  Fixed segue cue position (EOM) and visualizing segue duration.
  If more information stored in these files is needed let us know which and we'll read it.
- Fixed total number of tracks not being read correctly from ID3v2 tags.

Filtering:

- Powerful new file list filter, reworked from the ground up.
  Multiple match terms can now be specified, and for refinement they can be +included and -excluded.
  While substrings or phrases are written without quotes, or are put in double quotes,
   whole words can now also be matched when put in single quotes.
  Wildcards are auto-detected. Many more features are available.
  Full documentation on the new filter is available here: https://resonic.at/docs/file-list
- Filter panel is now kept open by default.
  If the filter is active the 'X' button will clear its text, another click on 'X' will close the panel.
  CTRL+F always toggles the filter panel regardless of the selected options.
- Filter open/close/focus logic reworked for better usability.
  Press ESC to select the filter text and to switch the input focus back and forth focus between
   file list and filter. This allows you to quickly switch to the file list with
- New filter options for all editions:
  'Automatically close panel' automatically closes the panel when not needed
  'Clear filter text on close' clears entered filter text as soon as the panel is closed
  'Close filter on Escape' closes the filter when ESC is pressed
  'Clear filter text on Escape' clears entered filter text when ESC is pressed
- The following file list shortcuts now also work while you are typing in the file list filter (CTRL+F):
  ESC (switch between file list and filter, depending on settings)
  CTRL+ENTER (open file in Explorer)
  ALT+ENTER (show file properties in Explorer)
  CTRL+SHIFT+ENTER (open file's parent folder in Explorer)
  ALT+F4 (to close the application)

Beta 0.9.3 (2019-03-21)
~~~~~~~~~~~~~~~~~~~~~~~

Remarks:

- A dedicated button on the right-hand side of the status bar indicates the type of device that is in use,
   i.e., NONE, ASIO, WAS (WASAPI), WAS-EX (exclusive WASAPI), or DS (DirectSound).
  Click it to go directly to the audio output device options.
- Note that all buttons that show a tiny arrow in the bottom right when you hover over them
   can be right-clicked for a context menu, exposing more functionality.

Stability:

- Resonic now warns you on startup when settings cannot be saved properly, or
   the Windows Defender 'Controlled folder access' feature might be affecting Resonic's operation.
  Learn more: https://resonic.at/notes/windows-defender
- Pro: Resonic now warns you when audio extraction fails because of full or write-protected disks.
- Fixed a randomly occuring crash that could be triggered by resizing the meta panel.
- Fixed a possible deadlock when using the filter while scanning folders.
   (reported: A. Mor)
- More resilient save and restore of preferences.

Usability:

- File operations (e.g., file deletes) that require a user interaction (e.g., on missing permissions)
   will now show a dialog instead of failing silently.

Integration:

- Restored Windows Vista compatibility. Be advised though that Vista support
   will be removed for good in a future update.
- Pro: 'Fix filenames for Unreal Engine' option that makes filenames produced by Resonic drag & drop
   extraction + slice export, and cropping, digestable by the Unreal Engine's bowels,
    counteracting a bug in UE asset file handling. (093-2)
  To change the option click the marker button (next to A-B button) and find the option in each of the
   two independent 'Extraction settings' menus. (reported: M. Gray)

User Interface:

- Pro: The header bar now shows the tempo in bpm, when available from the file's embedded metadata,
   or alternatively an educated guess based on filename and other metadata. (093-5)
  Also shown is tempo in bpm with the pitch shifting _applied_, i.e. after changing the audio frequency,
   which goes hand in hand with the duration and pitched duration displays.
- Implemented some 'High DPI' improvements for the browser.
- New button in sound preferences that opens the Windows sound control panel
   or the ASIO driver control panel for the selected device in sound preferences.
  The button ('...') is located right of the device selection.
- Fixed a tooltip drawing issue.
- Faster meta panel updates.
- Added 'Show level meter' to visualization button context menu.
- Axed colors in status bar notifications when switching between click modes (SCM/DCM)
   or operating modes (DETAIL/BULLET).
- New experimental oscilloscope visualization, accessible via menu, button, or F12. (093-8)
  Channels are mixed down to mono, and a fixed 50 ms window is being used (i.e., the width can fit ~20 Hz.)
  A left click seeks to an absolute position in file, just like it does with the other visualizations,
   and is not tied to any oscilloscope functions.
- You can now click the Resonic logo to open the about box, or CTRL+click it to open the website.

Waveform:

- Pro: Any number of sampler loops (e.g., sustaining/release) and generic regions embedded in WAV and AIFF
   audio files are now visualized in the waveform view, and can be used for looping. (093-10)
  Like most parts of Resonic they are currently still read-only and can thus not be altered.
- Pro: Bigger and more visible selection drag rectangle.
- Eliminated two minor glitches (ruler, and when waveform not loaded yet.)

File List:

- Some columns could not be set to reasonable sizes on high-resolution (e.g., 4K) screens.
   (reported: J. Rubens)
- Corrected rename logic. When renaming a file (F2) the focused file now takes precedence,
   followed by the first selected file, and finally the active (loaded) file.
    (reported: R. Radet)
- Pro: Fixed customized file list copy not working via context menu, but only via shortcut
   (CTRL+ALT+SHIFT+C).

Sound:

- Pro: The 'Sample rate' setting in sound preferences lets you select a desired sample rate
   to open the output audio device with. (093-4)
  For ASIO devices: When a specific sample rate is selected the ASIO driver will be instructed to switch
   the device to that rate. To leave the device rate untouched select 'Let driver decide', which is
    important when using ASIO in multi-client mode, i.e., multiple applications actively use the same driver.
  Most ASIO devices are limited to ASIO/WDM multi-client (e.g., ASIO in one main application, WASAPI
   in several others at the same time) and only a few devices (e.g., RME) support ASIO/ASIO multi-client
    (e.g., ASIO in several applications at the same time).
  In any case, when using an ASIO card in multi-client mode, sample rates must match across all applications
   actively using the driver, so it is best to keep the sample rate option on 'Let driver decide',
    and let another application be the sample rate master.
- Experimental exclusive WASAPI mode lets you select sampling rate, channel count, and dithering (TPDF).
  This is a work in progress in need of your feedback!
- Pro: 'Channel offset' setting in sound preferences renamed to 'First output' for clarity,
   and extended with a channel selection button ('...') that shows your ASIO output channels
    and lets you pick the first channel by name. (093-7)
  This is mainly useful for soundcards with many different output channels.
- Pro: Visual selection of the first output channel for ASIO devices in sound preferences.
  The new button ('...') is located right of the 'First output' input box.

Conversion:

- Pro: Fixed uninitialized batch targets not processing files properly.
   (reported: B. Geller)

Metadata:

- Pro: Metadata support and new file list columns: (093-1)
  - 'Origination Date' (combined BWF origination date and time)
  - 'Sample Type' shows whether file is a loop or a one-shot, if known (visible by default)
  - 'Tech Flags' shows which information sources are available in the file's metadata (e.g. BWF, CART)
   and were read by the Resonic meta core.
  - 'Master Speed' shows the iXML master speed value in frames per seconds (e.g. 29.97)
  - 'Current Speed' shows the iXML current speed value in frames per seconds
  - 'Time Signature' shows the musical meter (e.g. 4/4) (also available for MIDI files, initial meter)
  To enable any of these columns right-click the file list, and select 'Columns'.
- Pro: Read and use release dates embedded in Soundminer metadata.
- Pro: Read disc IDs (CD serials) embedded in certain files (e.g. iTunes mp4, xiph),
   display in meta panel.
- Pro: Read and display (not use!) various embedded replay gain settings,
   including ReplayGain v1/v2 track/album gain and peak, algorithm, R128 loudness level and range,
    and R128 album gain for Opus (Opus playback ignores the gain by default.)
- Pro: Corrected display of sample values in meta panel (track/album peak, etc.),
   now also displaying value in its dBFS representation.
- Less restrictive parsing and merging of partial dates,
   e.g., 2019-00-00 is widely used by tagging software and now accepted as well.
- Pro: Time signature is read from Standard MIDI files (only first change is used) (093-9)
- Pro: More resilient iXML loader now loads potentially damaged content (produced by certain
   Sound Devices hardware.)

Filtering:

- Pro: New filter option 'Match all words' (see filter options, or press ALT+A when the filter
   box is open) makes Resonic match all words instead of an exact phrase. (093-6)
  There is also a new button in the filter bar showing either "wrds" (match words) or "phrs" (match phrase.)
  For example, "car off" would then also match "car driving off". (suggested: A. Turner)
- Changed button captions in filter bar for clarity:
  - "cs" becomes "case" for case-sensitive matching, and
  - "*?" becomes "wild" for wildcard matching (using * and ? placeholders.)
  - "fn" remains as it is for filename-only matching.

Beta 0.9.2 (2018-12-12)
~~~~~~~~~~~~~~~~~~~~~~~

This release is an accumulation of fixes, features, and performance improvements in both Resonic Pro and Player.
Features include reworked file list usability, an improved 'Double Click Mode', 'Sticky selections',
 fast file list scrolling, browser folder history, per-device ASIO channel offsets (Pro), mono mix (Pro),
  and custom pause after tracks (Pro).
Improvements have been made around overall usability, 'High DPI' support, playback buffering, and batch targets (Pro).
The Pro version is upgraded with the long-awaited 'bullet mode' for browing very large amounts of audio files
 with the lowest possible application overhead, much improved metadata support (e.g., Soundminer),
  and a new meta panel which presents a lot of the information from the Resonic Meta Core.

New Features:

- Explorer file type icon for bookmarkable MP4 audio files (.m4b).

Improvements:

- Opus decoder updated to libOpus 1.3

Performance:

- Pro: The new 'Bullet Mode' puts Resonic into an operating state that optimizes
   many parts of the program including the UI for very fast browsing through very large
    amounts of files (several hundreds of thousands and more.)
  In bullet mode only the most basic information is displayed, metadata scans and info bar
   are both disabled, and thus most file list columns will remain empty.
  This mode can be toggled using a textual button on the right-hand side of the the status bar.
  When enabled the button reads 'BULLET', otherwise 'DETAIL' for full detail mode. (092-1)
- Greatly improved file listing performance.
- Improved UI drawing performance.

Stability:

- When Resonic crashes so-called crash dumps are written to disk. These .dmp files help
   us locate and fix the issues that caused the crash, so we can deliver an update.
  Use 'Open crash dumps folder' in 'Menu | Advanced' to open the folder that contains all these
   crash dumps, and email us the latest batch of .dmp files along with a description
    of what you have been doing before the crash happened. (093-2)
- Fixed several reported crash bugs. Thanks everyone!

Usability:

- Dynamic fast-scrolling for file list and browser.
  Hold down CTRL and use WHEEL to jump across the file list in coarse but even steps,
   regardless of whether there are 500 files in the list, or 50000.
  This allows you to quickly jump to a certain spot in the list without having to immediately
   go for the scrollbar thumb.
- Pro: CTRL+ALT+SPACE will now shuffle the current list ('Shuffle list'). (092-9)
  It is now also possible to set up a global shortcut for this feature. (suggested: J. Prange)
  Reminder: ALT+SPACE plays a random item from the current list.
- Browser and file list popup menus dynamically hide commands that make no sense
   for the clicked item instead of being greyed out,
    e.g., if a folder cannot be bookmarked then "Bookmark" won't be shown.
- Stop mode button ('Stop after current') is no longer disabled while looping.
- Updated shortcuts for mute/dim:
  Press the PAUSE/BREAK key (next to SCROLL LOCK) to toggle mute.
  Hold down the PAUSE/BREAK key to temporarily reduce volume (dim), release to restore volume.
  Press ALT+PAUSE/BREAK to toggle permanent volume reduction (dim.)
- Pro: It is now easier to access filter method/options in the filter menu popup. (092-15)
- A text file 'antivirus-readme.txt' is now included with every build of Resonic.
  It's in your own interest to have a look at it.
- CTRL+F now always shows/focuses the file filter, unless it's already focused,
   in which case it's closed.
- Pro: After recording you can click the status message to go to and play the new file.
- Pro: Trying new unstable test builds is now much easier when you already have
   Resonic Pro installed on your system.
  Simply download a new portable test build .zip, unpack it to a writable location (e.g., Desktop)
   and run 'Resonic.exe' from there.
  You will not have to enter your license every time.

Integration:

- Fixed --browse command line parameter.

User Interface:

- Minor preparations for DPI-aware UI rendering and multi-monitor improvements.
- Fixed window position restore when using multiple monitors.
- All list font size/spacing presets now also in Player.
- Pro: Launch modes added to play/pause right click menu for quick toggling
   ('Play immediately' and 'Prepare and pause'). (092-2)
  Note that these features are combinable with the ''Double Click Mode'' (DCM) option. (092-8)
- Updated splash screens for both versions of Resonic.
- The 'Resonic now running in background' notification that is shown once per session when
   Resonic is minimized to tray (ALT+M, or automatically via option) has become unbearably
    annoying on Windows 10, so we zapped it.
- Font size presets are generally a step bigger now (small was too small).
- New taskbar quick control button for volume dimming (Windows 10.) (092-11)
- Pro: Error messages when trying to record/pitch while using a DirectSound output device,
   which both requires a WASAPI or ASIO device.
- Resonic will now offer to open the whatsnew.txt once after updates.
- Pro: The hotkeys dialog has been adjusted to fit the theme. (092-3)

Playback and Monitoring:

- Pro: The 'Mono Mix' button completes the basic monitoring section (Dim, Mono, Mute).
  When 'Mono Mix' is active all audio channels are downmixed (summed) to mono,
   and the 'Stereo Crossfeed' (headphones button) becomes inactive.
- Pro: Trim volume control (gain) next to vertical zoom (peak scale) lets you amplify
   or attentuate the playing audio file in the range -48..+24 dBFS.
  The waveform display is adjust accordingly, vertical zoom is disabled. (092-7)
- Pro: The A-B button now works as 'Select all' (like CTRL+ALT+A) when playback is stopped
   and nothing is selected.
- Resonic now plays back audio from some 3GPP mobile phone files (.3gp, .3g2, .3gpp, .3gp2)
   through Windows Media Foundation on Windows 7+.
- Resonic now plays back audio from AMR/AMR-WB (Advanced Multi-Rate/Wideband) (.amr) audio files
   through Windows Media Foundation on Windows 10+.
- Pro: The setting 'Pause after each track' lets you set a fixed amount of time to wait after
   each track or file before auto-advancing to the next one.
  See 'Menu | Playback'. (092-13)
- Pro: The setting 'Ensure minimum track length' lets you set the minimum duration for each
   track/file before auto-advancing to the next one.
  When the track is shorter than the minimum Resonic will stop playback, wait, then continue.
  When the track is longer than the minimum Resonic will just continue, and optionally
   use the 'Pause after each track' setting to insert an additional delay.
  With these settings you can adjust Resonic to your own working speed.
  See 'Menu | Playback'. (092-14)
- Bigger playback buffers at a little extra RAM cost for smoother playback (ASIO/WASAPI).

Browser:

- Added basic browser folder history functionality.
  ALT+LEFT browses backwards, ALT+RIGHT browses forward in the folder history.
  There is a folder button in the top left corner as well that keeps track of the folders
   you have visited in the current session. It is cleared when Resonic is closed. (092-6)
- To go one level up, to the parent folder, you can now press BACKSPACE (or ALT+UP).
- Explorer-like Drag & Drop, i.e. copy for different drives, move for same drive.
  Move and copy operations can be forced by holding down CTRL and SHIFT.
- Fixed highlighted partially expanded folders not being shown in italic.

File List:

- Reworked selections and usability, and made things more compatible with Windows Explorer.
- Introducing a focused item (green rectangle), in addition to the selected items (blue)
   and the active (playing) item (green.)
  In 'Single Click Mode', which is the default behavior (i.e., a click plays a file)
   this new focused item is usually synchronized with the active item (i.e., playing file.)
  In 'Double Click Mode' (i.e., a click selects a file, a double-click plays a file)
   the new focused item can be used independently from the active (playing) item which greatly
    expands usability in some cases. (092-4)
- You can now quickly switch between 'Single Click Mode' (SCM) and 'Double Click Mode' (DCM)
   with a new status bar button in the bottom right.
- Improved 'Double Click Mode' (i.e., click selects a file, double-click plays a file).
  A toggle option was added to the file list menu.
- Introducing the 'Sticky selections' feature which allows you to play, select, and navigate
   the file list independently.
  Selections become sticky, i.e., they are kept until you press ESC to clear them,
   or change the playlist (e.g., switch another folder), which allows you to select items
    multiple times using keyboard or mouse without losing the previous selections.
  In 'Single Click Mode' focus and active (playing) item are synchronized.
  In 'Double Click Mode' focus and active (playing) item are untied, which means you can navigate
   the list independently from the active item, and select independently as well. (092-4)
- New shortcut: INS (INSERT) lets you toggle an item's selection state.
  This classic Norton Commander behavior is well known amongst users of FAR Manager,
   Total Commander, Windows Commander, WinNc, and similar software.
  When you use the INS key to select items the file list will automatically go into 'Sticky selections'
   and you won't lose any of your selections until you switch folders or playlists.
  To clear the selections manually press ESC.
- The file list will no longer auto-scroll to the playing item on automatic track
   advance when you have one or more items selected.
- Fixed a possible deadlock when the filter was active (reported: A. Frei).
- Improved file list responsiveness, especially while metadata is being scanned.
- Fixed occasional custom column order weirdnesses.
- Pro: Fixed some shortcuts starting playback in 'Prepare and pause' (cue ready) mode
   that should not start playback, which includes UP/DOWN, CTRL+UP/DOWN, ALT+SPACE.
  On click this mode loads a track ahead and pauses, but does not start playback.
   (reported: A. Marcotte)
- Fixed 'Shuffle list' not resetting the order after folder changes.
- The 'Shuffle list' feature will now always try to keep the active item centered. (092-9)
- Fixed a bug where the main column could suddenly jump from 'File Name' to 'Content Kind'
   after using 'Restore defaults'.
- Fixed MENU/APPS key not opening the context menu for the focused file.

Sound:

- Pro: A 'Channel offset' can now be set for each individual ASIO output device.
  This is particularly useful when your ASIO device has 8+ output channels (e.g., MADI)
   and you need to make sure that Resonic starts at a specific channel. (092-5)
- Pro: Audio extraction from MOD/MIDI files (i.e., music files rendered by Resonic)
   now takes into account the soundcard's output sampling frequency,
  This fixes issues where decoded music files were having the wrong pitch.
- Pro: Recordings now use temporary files (.$$$) which only show up in Resonic once the recording
   has finished properly. In case your 'Recorded Audio' folder (see bottom of browser) does
    not show the newly recorded files fast enough use F5 to refresh the file list.

Conversion:

- Pro: Removed several interpolation quality settings only leaving 'Low', 'Medium', and 'High',
   with 'High' being the maximum and also the default. (092-11)
- Pro: Updated batch targets popup menu, settings, and logic:
  You now explicitly set each batch target to either 'Copy', 'Move', 'Decode', or 'Process'
   any files dropped onto it.
  Use 'Copy' or 'Move' to only copy/move files to the target folder.
  Use 'Decode' to only decode input files to the selected output file format.
  If you want to use sample conversion you have to set it to 'Process'.
  Copy/move can be inverted using CTRL or SHIFT during drag, just like anywhere else.
- Pro: Support for headerless RAW output (.raw), in addition to RIFF WAVE (.wav). (092-16)

Metadata:

- Fixed displayed duration for Sony DSF high-resolution audio files (.dsf).
  Affected files are automatically rescanned.
- Additional information in info bar for MIDI files: track count, PPQN,
   and the sample rate the MIDI file was rendered at.
- Pro: Resonic now also tries to read BWF metadata from Broadcast Wave chunks with
   invalid versions (some software seems to write versionless, thus broken, BWF chunks),
    but will be reporting it as metadata integrity issue in a future update.
- Pro: Metadata support and new file list columns:
  'Category' (Soundminer, generic)
  'Sub Category' (Soundminer, generic)
  'Original Filename' for name of original/preferred filename (iXML, Soundminer, generic)
  'Library Title' for name of sound library a file is part of (Soundminer, generic)
  'Microphone' for microphone make or model used to create the recording (Soundminer, generic)
  'Recording Device' for recording medium, recording device, or recorder make or model
   used to create the recording with (Soundminer, generic)
  'Recording Type' (field recording, midside, etc.) (Soundminer, and generic)
  'Location' for location or place the recording was created at (RIFF, AIFF, Soundminer, generic)
- Pro: Improved overall support for Soundminer metadata.
- Resonic now lists files that begin with file extensions (e.g. "XM.some tune".)
  One of the rare cases where you might encounter such files is in the demoscene:
   module music files, found individually or in packs and collections, might originate
    from other systems (e.g. Amiga) that use different naming schemes. (092-10)

Web:

- The official discussion forums are now GDPR-compliant, use a dark styled responsive design
   that works on mobile devices, and were relocated to https://forums.liqube.com

Beta 0.9.1 (2018-01-24)
~~~~~~~~~~~~~~~~~~~~~~~

This release introduces a disk cache that makes already scanned metadata available much faster,
 and comes with much improved Drag & Drop features.
Metadata in DSD audio files (DSF/DFF) is fully supported (some parts in Pro only),
 new shortcuts were added, usability and integration has been improved,
  and lots of little things have been fixed.
Also, the currently playing path is now highlighted in the browser.

Performance:

- Introducing a high-performance metadata cache that runs transparently in the background.
  Once new files have been discovered this feature greatly reduces disk accesses,
   making existing metadata available much faster.
  The cache is limited to approximately 128 MB and cleans itself up every now and then.
  When the file list is focused you can issue a complete metadata re-read for all
   listed files by using CTRL+F5.
- You can now edit files in external programs while they are open in Resonic.
- Most of the file operations in Resonic now operate lock-free, which means that files
   can be used and handled in parallel more easily.
- Reduced memory usage in certain usage scenarios.

Usability:

- Pro: Shortcut to double (CTRL+SHIFT+D) and halve (CTRL+SHIFT+F) the selection length.
- Pro: Fixed multiple Drag & Drops of the same waveform selection from Resonic into other applications
   that immediately lock the received files (e.g., Ableton Live), which failed silently.
    (reported: Mr. Bill)
- Pro: You can now click the status bar message after recording to play the recording.

Integration:

- Game Audio: Improved Drag & Drop of audio files into Wwise (tested on 2017.1.4),
   which works around the program's file access issues ('File already open in another process').
- Added options for improved Drag & Drop usability. When dragging files out of Resonic,
   you can choose to bring the target window to the front or minimize Resonic.
  When Resonic is maximized or in fullscreen mode, dragging files to any edge of the
   screen will minimize the window.
  Playback will optionally be paused after successful drops.
- Support the recently added Windows 10 feature 'Scroll inactive windows when I hover over them'.

User Interface:

- Resonic is now more reliably brought to foreground when starting a second instance.
- Input boxes are now scaled to screen width.
- Fixed window position restore for nonstandard taskbar positions.
- Fixed a problem that occured when the Windows taskbar was set to auto-hide.
- Fixed tooltips disappearing in certain screen locations.

Playback and Monitoring:

- The UP and DOWN arrow keys will no longer play the next/previous file, but a random file,
   when the 'Random' playback mode is enabled.
  Note that you can also use ALT+SPACE anytime to play a random file.
- Pro: Fixed MIDI file playback only producing silence when using integrated ResonicProGM sound bank.
   (reported: D. Coscarella)
- Bigger playback buffers (at a little extra RAM cost) for smoother playback.
- Fixed a problem where seeking failed in very long AAC files (~2.5 hours and above.)
   (reported: Slax)
- Info bar now shows 'Float' to indicate floating point WAVE/AIFF files (32/64-bit),
   and was also made more readable.

Waveform:

- Resonic will now automatically rescan waveforms and metadata for files
   that you modify in external programs.
- Pro: Setting temporary slices (ALT+click) will no longer seek or start playback
   when the stream is paused or stopped.
  You can now slice up your file while stopped and export slices without actually having to listen
   to the file, which is more consistent with SHIFT+SELECT behavior.

Browser:

- As a visual cue the currently playing (active) file's path is now highlighted in green.
  An option to disable this feature is available.
- Fixed pasting files in browser, which could lead to a crash.
- Fixed an issue with ejecting CDs or DVDs.
- Pro: 'Copy path to clipboard' (folder context menu, or CTRL+SHIFT+C when browser focused)
   copies the currently selected folder's full path to the clipboard.

File List:

- Played files now appear dimmed until the file list changes or is is refreshed,
   as a helpful visual cue for improved workflow.
- File list filter now handles UP and DOWN arrow properly in 'Random' playback mode.
- Fixed file selection issues after file delete.
- Fixed file list contents not being updated properly in certain cases.
- Added new 'Follow active item' option. When disabled, the list will not scroll
   after automatic track changes. (suggested: J. Frankel)
- Fixed content kind image not being drawn in some custom column configurations.
- Fixed metadata not being read from files with the read-only attribute set.
- File list clipboard export improved.
  'Export file list | Copy file paths' (file context menu, or CTRL+SHIFT+C when file list focused)
   copies plain text unescaped paths.
  Resonic Pro can also copy the path names (without file names), or just the file names.
- Pro: File list clipboard export customization added to file context menu under
   'Export file list | Customization', which is most useful to power users and developers.
  Also added new command 'Copy customized file paths' (CTRL+SHIFT+ALT+C).
  Added new selection of backslashes or forward slashes as directory separator. (091-2)
- More explicit notifications when files are copied (green) and cut (yellow).
  The same concept applies to browser folders.

Conversion:

- Pro: Ten additional less common sample rates for batch targets (e.g., 8, 11.025, 32, 44.056, 192),
   accessible through the 'Sample Rate' submenu. (091-1)
- Pro: Resonic Pro will now use 32-bit Float as default output format for slicing/extracting.
- Pro: When dragging selections out or saving slices Resonic now correctly creates 32-bit Float
   output files from 32-bit Float input files when 'Same as input file' is used as 'Bit Depth'.
  Previously, Resonic created 32-bit PCM output files by default, which pointed out a serious bug
   in Ableton Live where 32-bit PCM wave files are misinterpreted as loud noise.
    So dear Live users, do yourself a favor and stick to 32-bit Float.
     (reported: Mr. Bill)

Metadata:

- When the file list is active CTRL+F5 now triggers a full reload, including all metadata.
- Metadata support for Sony DSF high-resolution DSD audio files (.dsf),
   which are commonly used for consumer content.
  The following information is now read by the Resonic meta core:
   playback duration, sample rate (mhz), channel count, sample count, bit depth, as well as
    most information in embedded ID3v2 tags.
- Metadata support for Philips DSDIFF high-resolution DSD audio files (.dff),
   which are commonly used for professionally authored content.
  The following information is now read by the Resonic meta core:
   playback duration, sample rate (mhz), channel count, sample count, comments, artist, title,
    software ('creating machine'), engineer ('operator name'),
     and in the Pro version: source form ('sound source'), file structure, file integrity checks.
- Improved the Resonic meta core's ability to auto-correct RIFF WAVE files with broken headers,
   and continue to read the remaining metadata.
  However, playback duration is intentionally not reported to easily spot problematic files.
  Future Pro versions may report these errors differently.

Beta 0.8.9 (2017-08-02)
~~~~~~~~~~~~~~~~~~~~~~~

This release updates both Player and Pro, and introduces the first set of Pro features for batch
 processing ('Batch Targets'), a what-you-hear recording feature (record button), it improves
  the musical spectrum, adds metadata support for MIDI files, adds basic CART metadata support
   for radio automation users, lets you start different copies (not instances) of Resonic
    at the same time,  and comes with many bug fixes.

New Features:

- Pro: Batch Targets feature (batch processing.)
  Fixed copy/move/decode/convert target folders can be created in the new right sidebar
   (which can be toggled with F6, analogous to the left sidebar and F4) by dragging folders
    onto the 'Targets' tab.
  Each target can receive files and folders for whatever action is assigned to it.
  Additional conversion options are available through the RIGHT-CLICK menu, ranging from
   simple copy/move to audio decoding (to .wav), sample format conversion (bit depth,
    sample rate, channel count).
  Targets are accessible from the (new) right sidebar (through F6, or the button in the status bar),
   which is shown by default on first start of a fresh installation.
  More features are to be added in future versions.
  See https://resonic.at/docs/batch-targets for more information.
- Pro: Recording feature ('what you hear'.)
  Press the record button (transport bar) to record what is currently being played through Resonic,
   including pitch shifting, volume, seeking, live looping, and slice triggering via keyboard keys.
  Recorded audio is stored as .wav files in the 'Recorded Audio' folder in the Resonic user
   profile (in user 'Documents') which is also directly accessible through the browser.
  This feature is intended to be used for sound design, creative idea finding, or as an audio sketch pad.
  To use recording you must use either a WASAPI or ASIO device for playback.
  See https://resonic.at/docs/recording for more information.
- Pro: Musical spectrum and its note/octave estimation have been reduced to a more
   useful range of keys (C0..G8), bar scaling has been updated, bars are now colored
    by average intensity, and fading peak hold has been added.
- Musical spectrum eye candy in Player, too:
   Frequency bars are dynamically shaded based on their relevance (089-1)
- Pro: Standard MIDI files are now fully integrated into the Resonic meta core,
   estimating MIDI file duration, reading copyright, timed markers with labels,
    musical key (first key signature change), track count (non-empty tracks),
     MIDI format (0, 1, or 2), pattern count (for format 2 files), PPQ, and tempo in BPM.
  If there are multiple tempo changes in a file an average tempo will be displayed
   in the file list, and the BPM will be put in brackets.
  As a special feature Resonic also displays the number of unique instrument patches
   used in the MIDI file in the 'Instrument Count' column.
- Pro: Added 'Cropped Audio' to browser to quickly access this standard folder in the
   Resonic user profile (in user 'Documents'.)
- Pro: Crop progress display in status bar,
   for both the "Crop selection" and the "Crop selection and play" feature.
- Pro: Added RIGHT-CLICK menu to A-B button for a few selection commands.
  Note that the Play, Stop, and Headphones buttons also have their own RIGHT-CLICK menus.
- Pro: The current mouse-selected region in the waveform is now automatically saved before
   it is modified or cleared, which means you won't accidentally lose the the region.
  The last region can be restored by right-clicking the A-B button, or through the marker
   button menu, using "Restore last selection."
  If a region already exists and a new one is created this feature toggles between
   the last one and the current one.
  This feature is also available as a global hotkey.
- Pro: Much improved behavior of "Crop selection and play" feature (renders the selected
   waveform region to a new audio file and starts playing it):
  Before the new (cropped) file starts playing the selected waveform region is cleared,
   the current pitch settings (semitones/cents) are cleared, and the loop button
    is enabled (repeating the new file.)
  Note that the last selected region can now also be restored through the marker
   menu, or by right-clicking the A-B button ("Restore last selection".)
- Pro: New global hotkey for "Loop on/off", which toggles single-file repeat.
- Pro: AIFF metadata improvements, and reading comment chunks.
- It is now possible to run different copies of Resonic Pro and Player at the same time
   as long as the database paths are different.
  You could for example start a portable Player, a portable Pro, another portable Pro,
   and a regularily installed Pro in parallel.
  Starting the same copy multiple times is not supported yet; it was removed
   during the Alpha to Beta rework for database stability reasons.
- You can now CTRL+C the version information when the about dialog is open.
- Headphones crossfeed presets (BS2B); RIGHT-CLICK the headphones button
   to access them. (089-2)
- New item in column popup menu to quickly hide the clicked column.
- Pro: Metadata support for compressed AIFF files (.aifc).
- Added indication of floating point files in bit depth column (using an 'f', e.g., "32f")
- Pro: Additional metadata support for AES CART chunks.
   Available via columns: artist, title, category, cut id, client id, comment.
- Pro: Metadata support for Scott Studios (SS32) Wave files, used in radio automation
   and broadcast systems.
  Available via columns: artist, title, cut id, comment.
  Available via waveform: intro end position, segue position.
   (suggested: G. Zlot)
- Pro: Segue (track transition in radio automation), intro markers, and other CART triggers
   are now read from CART/SS32 metadata and displayed in Resonic's waveform as a dashed line.
- Pro: Addtional metadata support for BSI Wave files (Broadcast Software International),
   used in radio automation and broadcast systems.
  Available via columns: recording year, agency (as copyright), copyright / record label / publisher
   (as publisher), copy / notes (as subject), genre, music key, composer, album, tempo in bpm,
    and track number.
  Available via waveform: hook start position.
- Pro: Added new broadcast columns "Cut Number ID" and "Client ID" (CART).
- Essential fixes from the last Pro release were ported to Resonic Player.
- Utility feature to resize main window to a fixed size, offering a selection of preset sizes,
   which assists in making videos or screenshots of a certain size.
    (see 'Menu | Advanced | Resize main window'.)

Improvements:

- File list items appear faster when pasted (using the CTRL+V shortcut.)
- Faster startup with bookmarks that point to mapped network drives, or network locations.
- Folders can be moved and deleted more reliably as they are unlocked more intelligently
   when necessary, e.g., during Drag & Drop move in browser.
- More detailed information in column popup menu.
  It's also easier to find the clicked column and its metadata group
   which both now appear in bold.
- Opus decoder updated to libOpus 1.2.1 for reduced CPU usage during decoding.
   https://people.xiph.org/~jm/opus/opus-1.2/
- MIDI renderer now more resilient in handling invalid XG sysex messages.
- Slightly faster metadata scanning in Player by not reporting certain content.
- File list copy/paste improvements and fixes.

Corrections:

- Pro: Playback of REX2 mono files. (reported: the3ug3reeder)
- Fixed taskbar quick controls (buttons) disappearing after a while on Windows 10.
- Aborting a metadata scan in folders with lots of files could make one CPU core hang
   at a hundred percent usage. (reported: A. Tchernychov)
- Corrected several Drag & Drop related issues in the browser.
- Pro: Fixed error message shown on every key press when ''Map temporary slices to letter keys''
   is enabled (for fast slice auditioning) and there are no temporary slices set.

end of file.
